
Node = Struct.new(:datos, :siguiente, :anterior)

def Node
   undef datos=, []=
end

# = Clase Lista
# Representa la lista enlazada

class Lista
    include Enumerable
    #==Constructor
    #===Pasamos los parametros para construir un objeto Lista:
    def initialize ()
        @cabeza = nil
    end
    
    #* Borra el objeto de la cabeza de la Lista.
    def extraerCabeza
            auxiliar = @cabeza
            @cabeza = auxiliar.siguiente
            auxiliar.siguiente = nil
            auxiliar.datos
    end
    
    #* Inserta el objeto o grupo de objetos en la cabeza de la Lista
    def insertar (datos)
        insertado = false
        if datos.instance_of?Array
            datos.each{|x| add(x)}
            insertado = true
        else
            add(datos)
            insertado = true
        end
        insertado
    end
    
    #* Devuelve el objeto Menú que se encuentra en la cabeza de la lista.
    def cabeza
        @cabeza.datos
    end
    
    private
    
    def add (datos)
        if @cabeza == nil then
            @cabeza = Node.new(datos,nil)
        else
            nodo_aux = @cabeza
            while nodo_aux.siguiente != nil
                nodo_aux = nodo_aux.siguiente
            end
        nodo_aux.siguiente = Node.new(datos, nil)
        end
    end

end
# = Clase ListaEnlazada
# Representa la lista doblemente enlazada
class ListaEnlazada
    include Enumerable
    def initialize ()
        @cabeza = nil
        @cola = nil
    end
    
    def each
        x = @cabeza
        while x != @cola
            yield x.datos
            x = x.siguiente
        end
        yield @cola.datos
    end
  
    #* Borra el objeto de la cabeza de la Lista.
    def extraerCabeza
        if @cabeza != nil then
            auxiliar = @cabeza
            if @cabeza.siguiente != nil then
                @cabeza = auxiliar.siguiente
                @cabeza.anterior = nil
                auxiliar.siguiente = nil
            else
                @cabeza = nil
                @cola = nil
            end
            auxiliar.datos
        else
            @cabeza
        end
    end
    
    #* Borra el objeto que está en la cola de la Lista.
    def extraerCola
        if @cola != nil then
            auxiliar = @cola
            if @cola.anterior != nil then
                @cola = auxiliar.anterior
                @cola.siguiente = nil
                auxiliar.anterior = nil
            else
                @cola = nil
                @cabeza = nil
            end
            auxiliar.datos
        else
            @cola
        end
        
    end
    
    #* Inserta el objeto o grupo de objetos en la cabeza de la Lista
    def insertarCabeza (datos)
        insertado = false
        if datos.instance_of?Array
            datos.each{|x| addCabeza(x)}
            insertado = true
        else
            addCabeza(datos)
            insertado = true
        end
        insertado
    end
    
    #* Inserta el objeto o grupo de objetos en la cola de la Lista
    def insertarCola (datos)
        insertado = false
        if datos.instance_of?Array
            datos.each{|x| addCola(x)}
            insertado = true
        else
            addCola(datos)
            insertado = true
        end
        insertado
    end
    
    #* Devuelve el objeto Menú que se encuentra en la cabeza de la lista.
    def cabeza
        if @cabeza != nil then 
            @cabeza.datos
        else
            @cabeza
        end
    end
    
    #* Devuelve el objeto Menú que se encuentra en la cola de la lista.
    def cola
        if @cola != nil then
            @cola.datos
        else
            @cola
        end
    end
    
    private
    
    def addCabeza (datos)
        if @cabeza == nil then
            @cabeza = Node.new(datos,nil, nil)
            @cola = @cabeza
        else
            nodo_aux = @cabeza
            @cabeza = Node.new(datos, nodo_aux, nil)
            nodo_aux.anterior = @cabeza
        end
    end
    
    def addCola (datos)
        if @cabeza == nil then
            @cabeza = Node.new(datos,nil, nil)
            @cola = @cabeza
        else
            nodo_aux = @cola
            @cola = Node.new(datos, nil, nodo_aux)
            nodo_aux.siguiente = @cola
        end
    end
    
end
